#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/wait.h>
#include <signal.h>
#include <dirent.h>

#include "anonyboth.h"

/*This subroutine exits, printing an error message*/
void
bail (char *on_what)
{
  if (errno != 0)
    {
      fputs (strerror (errno), stderr);
      fputs (": ", stderr);
    };
  fputs (on_what, stderr);
  fputs ("\n", stderr);
  exit (1);
};

/*************************************************/
/*Read Message headers and send them to the client*/
int
Send_Headers (int c)
{
  FILE *tx;
  FILE *rx;
  FILE *msg;
  struct timeval timeOut;
  char buffer[BUFFER_SIZE];
  int c2;			/*to dup[licate the socket c */
  int z;
  char *zz;
  fd_set readSockets;		/*set of sockets to look for data on */
  int i,j;
  char fileName[FILE_SIZE];
  char title[BUFFER_SIZE];
  char parent[FILE_SIZE];
  char thread[FILE_SIZE];
  struct dirent *entry, **result;
  DIR *dirStream;

  FD_ZERO (&readSockets);
  timeOut.tv_sec = TIME_SECS;
  timeOut.tv_usec = TIME_USECS;


  /*create a place to put directory entries */
  entry = (struct dirent *)malloc (sizeof (struct dirent));
  if (entry == NULL)
    bail ("malloc error");
  result = &entry;

/*  printf ("Socket %i\n", c);*/

/*create file descriptors to read/write from the socket*/
  tx = fdopen (c, "w");
  c2 = dup (c);			/*duplicate the socket */
  rx = fdopen (c2, "r");
  if ((tx == NULL) || (rx == NULL))
    {
      bail ("Child could not link fd to socket\n");
    };

/*we've already had the OK from the client*/
  FD_SET (c, &readSockets);	/*put my socket into the list */
  j = 0;
  if ((dirStream = opendir ("./")) != NULL)
    {
    i=readdir_r(dirStream,entry,result);
      while ((i == 0) && ((long)entry->d_name>0x100))/*second test to overcome bug in glibc*/
	{
/*	printf("Pointer to filename= %0x\n",entry->d_name);
	  printf ("DirRead result= %i:\n", i);
	  printf ("Filename %i given: ",j++);*/
	  strcpy (fileName, entry->d_name);
	  /*check to make sure it isn't the . or .. */
	  if ((strcmp (fileName, ".") == 0) || (strcmp (fileName, "..") == 0)
	      || (strcmp (fileName, "core") == 0))
	    {			/*it isn't a message */
	    }
	  else
	    {
	      msg = fopen (fileName, "r");
	      if (msg != NULL)	/*only send data if we can guarantee four bits */
		{
		  zz = fgets (buffer, sizeof buffer, msg);	/*get the title */
		  if (zz != NULL)
		    {
		      strncpy (title, buffer, sizeof (title) - 1);
		      title[sizeof (title) - 1] = '\0';
		      zz = fgets (buffer, sizeof buffer, msg);	/*get the thread */
		      if (zz != NULL)
			{
			  strncpy (thread, buffer, sizeof (thread) - 1);
			  thread[sizeof (thread) - 1] = '\0';
			  zz = fgets (buffer, sizeof buffer, msg);	/*get the parent */
			  if (zz != NULL)
			    {
			      strncpy (parent, buffer, sizeof (parent) - 1);
			      parent[sizeof (parent) - 1] = '\0';
			      /*by now we have four valid things to send */
			      fputs (fileName, tx);
			      fputs ("\n", tx);
			      fputs (title, tx);	/*\n is already there */
			      fputs (thread, tx);
			      fputs ("\n", tx);
			      fputs (parent, tx);
			      fputs ("\n", tx);
			      fclose (msg);
/*			      puts ("Ready to flush data");*/
			      if (fflush (tx)!=0)
			      	{
			      	printf("Failed to flush: %s\n",strerror(errno));
			      	}
/*			      puts ("Flushed");*/
			      /*now wait for response from sender, and bail if none arrives */
			      z = select (c2 + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
			      if (z > 0)	/*something to read */
				{
				  zz = fgets (buffer, sizeof buffer, rx);
/*				  puts ("ReadOK");*/
				}
			      else
				{
				  bail ("Client Failed to send OK\n");
				}
			    }
			}
		    }
		}
	      else
		{
		  puts ("Failed to open file :");
		  puts (fileName);
		  puts ("\n");
		};
	    }
     i=readdir_r(dirStream,entry,result);
	}
    }
  else
    {
      puts ("Couldn't open the directory\n");
    };

  shutdown (fileno(tx), SHUT_WR);	/*close the write socket */
 if (fclose (tx)!=0)
  	printf("Error closing tx: %s\n",strerror(errno));
  while (fgetc (rx) != EOF)
    {
    };				/*wait for the socket to be closed */

  free (entry);			/*release memory used for directory stuff */
  closedir (dirStream);
if (fclose (rx)!=0)
  	printf("Error closing rx: %s\n",strerror(errno));

};

/*********************************************/
/*Read a file and send the message to the Client*/
int
Send_Message (int c)
{
  FILE *tx;
  FILE *rx;
  FILE *msg;
  struct timeval timeOut;
  char buffer[BUFFER_SIZE];
  int z;
  char *zz;
  fd_set readSockets;		/*set of sockets to look for data on */
  int success = 1;
  int charCount, i;
  char fileName[FILE_SIZE] = "123456789012345678";

  FD_ZERO (&readSockets);
  timeOut.tv_sec = TIME_SECS;
  timeOut.tv_usec = TIME_USECS;

/*create file descriptors to read/write from the socket*/
  tx = fdopen (c, "w");
  rx = fdopen (dup (c), "r");
  if ((tx == NULL) || (rx == NULL))
    {
      bail ("Child could not link fd to socket\n");
    };

/*is there anything to read?*/
  FD_SET (c, &readSockets);	/*put my socket into the list */
/*try to read the filename*/
  fputs ("OK\n", tx);
  fflush (tx);
  z = select (c + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
  if (z > 0)			/*something to read */
    {
      zz = fgets (buffer, sizeof buffer, rx);
      if (zz != NULL)
	{
	  strncpy (fileName, buffer, sizeof (fileName) - 1);
	  fileName[sizeof (fileName) - 1] = '\0';
	  msg = fopen (fileName, "r");
	  if (msg == NULL)
	    {
	      puts ("Failed to open FILE: ");
	      puts (fileName);
	      putchar ('\n');
	      success = 0;
	    }
	};
    }
  else
    {
      success = 0;
    };
/*Send out the title*/
  zz = fgets (buffer, sizeof buffer, msg);
  if (zz != NULL)
    {
      fputs (buffer, tx);
    }
  else
    {
      success = 0;
    };
  fflush (tx);

/*receive an OK*/
  z = select (c + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
  if (z > 0)			/*something to read */
    {
      zz = fgets (buffer, sizeof buffer, rx);
      if (zz == NULL)
	{
	  /*read failure */
	  success = 0;
	};
    }
  else
    {
      success = 0;
    };

/*read in the thread and discard it*/
  zz = fgets (buffer, sizeof buffer, msg);
/*read in the parent and discard it*/
  zz = fgets (buffer, sizeof buffer, msg);

/*send the rest of the file*/
  z = fgetc (msg);
  while (z != EOF)		/*read one char at a time and put directly to the socket */
    /*this is to allow paragraphs to look good in auto sizing windows */
    {
/*		puts(".");*/
      fputc (z, tx);
      z = fgetc (msg);
    };
  fflush (tx);

  /*close all the streams */
  /*when socket is closed, the client will know all data has been sent */
  if (fclose (tx)!=0)
  	printf("Error closing tx: %s\n",strerror(errno));
  if (fclose (rx)!=0)
  	printf("Error closing tx: %s\n",strerror(errno));
  if (fclose (msg)!=0)
  	printf("Error closing tx: %s\n",strerror(errno));

  if (!success)
    {
      return -1;
    }
  else
    {
      return 0;
    };
};

/*******************************************/
/*Read a message and write it to a file*/
int
Receive_Message (int c, char *filename)
{
  FILE *tx;
  FILE *rx;
  FILE *msg;
  struct timeval timeOut;
  char buffer[BUFFER_SIZE];
  int z;
  char *zz;
  fd_set readSockets;		/*set of sockets to look for data on */
  int success = 1;
  int charCount;
  char thread[FILE_SIZE];
  char parent[FILE_SIZE];

  FD_ZERO (&readSockets);
  timeOut.tv_sec = TIME_SECS;
  timeOut.tv_usec = TIME_USECS;

/*open the file to store the data*/
  msg = fopen (filename, "w");
/*create file descriptors to read/write from the socket*/
  tx = fdopen (c, "w");
  rx = fdopen (dup (c), "r");
  if ((tx == NULL) || (rx == NULL))
    {
      bail ("Child could not link fd to socket\n");
    };

/*is there anything to read?*/
  FD_SET (c, &readSockets);	/*put my socket into the list */
/*Try to read the title*/
  fputs ("OK\n", tx);
  fflush (tx);
  z = select (c + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
  if (z > 0)			/*something to read */
    {
      zz = fgets (buffer, sizeof buffer, rx);
      if (zz != NULL)
	{
	  fputs (buffer, msg);
	};
    }
  else
    {
      success = 0;
    };
/*Try to read the thread*/
  fputs ("OK\n", tx);
  fflush (tx);
  z = select (c + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
  if (z > 0)			/*something to read */
    {
      zz = fgets (buffer, sizeof buffer, rx);
      if (zz != NULL)
	{
	  if (strncmp (buffer, "0", 1) == 0)	/*it is a new thread, so use the filename */
	    {
	      strncpy (thread, filename, sizeof (thread) - 1);
	    }
	  else
	    {			/*use the one sent by the client */
	      strncpy (thread, buffer, sizeof (thread) - 1);
	    };
	  /*set last bit of thread to end char */
	  thread[sizeof (thread) - 1] = '\0';
	  fputs (thread, msg);
	  fputs ("\n", msg);
	};
    }
  else
    {
      success = 0;
    };
/*Try to read the parent*/
  fputs ("OK\n", tx);
  fflush (tx);
  z = select (c + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
  if (z > 0)			/*something to read */
    {
      zz = fgets (buffer, sizeof buffer, rx);
      if (zz != NULL)
	{
	  if ((strncmp (buffer, "0", 1) == 0))
	    {
	      memset (parent, '0', sizeof (parent) - 1);
	    }
	  else
	    {
	      strncpy (parent, buffer, sizeof (parent) - 1);
	    };
	  parent[sizeof (parent) - 1] = '\0';
	  fputs (parent, msg);
	  fputs ("\n", msg);
	};
    }
  else
    {
      success = 0;
    };
/*try to read the text...*/
  fputs ("OK\n", tx);
  fflush (tx);
  z = select (c + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
  if (z > 0)			/*something to read */
    {
      z = fgetc (rx);
      charCount = 0;
      while ((z != EOF) && (charCount < MAX_MESSAGE_SIZE))	/*read one char at a time and put directly to the file */
	/*this is to allow paragraphs to look good in auto sizing windows */
	{
	  fputc (z, msg);
	  z = fgetc (rx);
	  charCount++;
	};
    }
  else
    {
      success = 0;
    };

/*close the file created and streams*/
  if (fclose (tx)!=0)
  	printf("Error closing tx\n");
  if (fclose (rx)!=0)
  	printf("Error closing rx\n");
  if (fclose (msg)!=0)
  	printf("Error closing msg\n");

  if (!success)
    {
      /*delete the file created */
      unlink (filename);
      return -1;
    }
  else
    {
      return 0;
    };
};

/*Process terminated Child processes*/
/*all this does is check to see if they are finished*/
/*if they are, the cleanup is done by the system*/
static void
sigchld_handler (int signo)
{
  pid_t PID;
  int status;

  do
    {
      PID = waitpid (-1, &status, WNOHANG);	/*returns immediately */
    }
  while (PID != -1);
/*reinstate handler*/
  signal (SIGCHLD, sigchld_handler);
};

/****************************************************************/
/*Main Program*/
int
main (int argc, char **argv)
{
/*char srvr_port_str[8];*/
  struct sockaddr_in srvAddr;
  struct sockaddr_in clientAddr;
  int s;			/*for server socket */
  int c;			/*for client socket */
  int len_inet;			/*for the length of an address space */
  int z;			/*for errors and counting */
  pid_t PID;			/*for process control */
  char buffer[BUFFER_SIZE];
  time_t td;			/*current time-for filenames */
  int msgTimeCount = 0;
  char msgFileName[FILE_SIZE];
  char msgTimeDate[15];
  char msgOldTimeDate[15];
  struct timeval timeOut;	/*to limit the time to wait for data to be sent */
  fd_set readSockets;		/*set of sockets to look for data on */

/*change to the default directory*/
  if (chdir ("/var/AnonyNews/messages") != 0)
    bail ("Message Directory");

/*set the default time out*/
  timeOut.tv_sec = TIME_SECS;
  timeOut.tv_usec = TIME_USECS;

/*now create the server socket*/
  s = socket (PF_INET, SOCK_STREAM, 0);
  if (s == -1)
    {
      bail ("Socket");
    };
/*set up the server address*/

  memset (&srvAddr, 0, sizeof srvAddr);
  srvAddr.sin_family = AF_INET;
  srvAddr.sin_port = htons (PORT_TO_USE);
  srvAddr.sin_addr.s_addr = INADDR_ANY;	/*accept connections from any ip address */
/*bind the address to the socket*/
  len_inet = sizeof (srvAddr);
  z = bind (s, (struct sockaddr *) &srvAddr, len_inet);
  if (z == -1)
    {
      bail ("Bind");
    };
/*set the socket to listen*/
  z = listen (s, 10);
  if (z == -1)
    {
      bail ("Listen");
    };
/*set the old time date*/
  time (&td);
  strftime (msgOldTimeDate, sizeof msgOldTimeDate, "%Y%m%d%H%M%S",
	    localtime (&td));
/*now try to accept connections...*/
  for (;;)			/*forever loop */
    {
      len_inet = sizeof (clientAddr);
      c = accept (s, (struct sockaddr *) &clientAddr, &len_inet);
      if (c == -1)
	{
	  bail ("Accept");	/*currently exits if there is a problem */
	};
      //create a filename which may or may not get used*/
      time (&td);
      strftime (msgTimeDate, sizeof msgTimeDate, "%Y%m%d%H%M%S",
		localtime (&td));
      /*is this the same as the last one? */
      if (strcmp (msgTimeDate, msgOldTimeDate) == 0)
	{
	  msgTimeCount++;
	}
      else
	{
	  msgTimeCount = 0;
	};
      sprintf (msgFileName, "%s%04d", msgTimeDate, msgTimeCount);

      /*copy the timedate so we can see if it has been used before */
      strcpy (msgOldTimeDate, msgTimeDate);

/*fork a new process to serve each request*/
      if ((PID = fork ()) == -1)
	{			/*fork failed */
	  close (c);
	  continue;
	}
      else if (PID > 0)
	{			/*Parent Process */
	  close (c);
/*connect a handler for the SIGCHLD signal-sent on close of a child process*/
	  signal (SIGCHLD, sigchld_handler);

	  continue;
	}
      else
	{			/*Child Process-where the work is done */
	  write (c, "OK\n", 3);
	  /*is there anything to read? */
	  FD_SET (c, &readSockets);	/*put my socket into the list */
	  z = select (c + 1, &readSockets, NULL, NULL, &timeOut);	/*wait for timeout */
	  if (z > 0)		/*something to read */
	    {
	      z = read (c, buffer, sizeof buffer);
	      if (z > 0)
		{
		  /*Choose what the child process does at this point */
		  buffer[z] = 0;
/*			printf("Recieved %s",buffer);*/
		  if (strncmp (buffer, WRITE_MSG, 1) == 0)
		    {
		      printf ("Recieving message\n");
		      Receive_Message (c, msgFileName);
		    };
		  if (strncmp (buffer, READ_MSG, 1) == 0)
		    {
		      printf ("Sending Message\n");
		      Send_Message (c);
		    };
		  if (strncmp (buffer, READ_MSG_HEADERS, 1) == 0)
		    {
		      printf ("Sending Headers\n");
		      Send_Headers (c);
		    };
		  /*default is to exit if they send the wrong code */
		};
	    }
	  else
	    {
	      bail ("Child Timeout Waiting for Instruction to be Sent.\n");
	    };

	  puts ("Last Message\n");
	  /*Child must exit at some point */
	  exit (0);
	};

    };				/*end of forever loop */

}
